#include <sys/mman.h>

#include <err.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "dev.h"

int
main(int argc, char *argv[])
{
	vm_offset_t addr = 0;
	size_t len = 512 * 4096;
	int fd;

	if ((fd = open("/dev/wiredev", O_RDWR)) < 0)
		err(1, "open(/dev/wiredev)");

	if (ioctl(fd, DEVIOC_MAP, &addr) != 0)
		err(1, "ioctl(DEVIOC_MAP)");

	for (vm_offset_t cur = addr; cur < (addr + len); cur += 4096) {
		*(int *)cur = 1;
	}

	mprotect((void *)addr, 4096, 0);
	for (vm_offset_t cur = addr + 4096; cur < (addr + len); cur += 4096) {
		*(int *)cur = 2;
	}
	printf("about to fault\n");

	// should fault
	*(int *)addr = 1;

	close(fd);

	return (0);
}
